//+------------------------------------------------------------------+
//|                                                               XO |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width3  2
#property indicator_width4  2
#property strict

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern double BoxSize          = 6.5;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "XOarrows";
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Orange;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

string ForSymbol = "";
double xowu[];
double xowd[];
double xobu[];
double xobd[];
double no[];
double kr[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(7);   
      SetIndexBuffer(0,xowu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,xowd); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,xobu); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,xobd); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,kr);
      SetIndexBuffer(5,no);
      SetIndexBuffer(6,trend);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
            if (StringTrimLeft(StringTrimRight(ForSymbol))=="") ForSymbol=Symbol();

      //
      //
      //
      //
      //
      
   IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" XO ("+DoubleToStr(BoxSize,2)+")");
   return(0);
}
int deinit()
{
   if (!calculateValue && ShowArrows) deleteArrows();
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double Hi[];
double Lo[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { xowu[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
    
   if (calculateValue || (ForSymbol==Symbol() && timeFrame == Period()))
   {
      if (ArraySize(Hi)!=Bars) ArrayResize(Hi,Bars);
      if (ArraySize(Lo)!=Bars) ArrayResize(Lo,Bars);
      
      double pipModifier = 1; if (Digits==3 || Digits==5) pipModifier=10;
      for(i=limit,r=Bars-i-1; i>=0; i--,r++)
      {         
         if (i>=(Bars-2)) { Hi[r]=Close[i]; Lo[r]=Close[i]; continue; }

         //
         //
         //
         //
         //
      
         double cur = Close[i];
         Hi[r]    = Hi[r-1];
         Lo[r]    = Lo[r-1];
         no[i]    = no[i+1];
         kr[i]    = kr[i+1];
         trend[i] = trend[i+1];

            if (cur > (Hi[r]+BoxSize*pipModifier*Point)) { Hi[r] = cur; Lo[r] = cur-BoxSize*pipModifier*Point; kr[i] =  1; no[i] = 0; }
            if (cur < (Lo[r]-BoxSize*pipModifier*Point)) { Lo[r] = cur; Hi[r] = cur+BoxSize*pipModifier*Point; no[i] = -1; kr[i] = 0; }
               if (kr[i] > 0) trend[i]= 1;
               if (no[i] < 0) trend[i]=-1;
               if (trend[i] ==  1) { xowu[i] = High[i]; xowd[i] = Low[i]; xobu[i] = MathMax(Open[i],Close[i]); xobd[i] = MathMin(Open[i],Close[i]); }
               if (trend[i] == -1) { xowd[i] = High[i]; xowu[i] = Low[i]; xobd[i] = MathMax(Open[i],Close[i]); xobu[i] = MathMin(Open[i],Close[i]); }
            manageArrow(i);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars","",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
         trend[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",BoxSize,6,y);
         if (trend[i] ==  1) { xowu[i] = High[i]; xowd[i] = Low[i]; xobu[i] = MathMax(Open[i],Close[i]); xobd[i] = MathMin(Open[i],Close[i]); }
         if (trend[i] == -1) { xowd[i] = High[i]; xowu[i] = Low[i]; xobd[i] = MathMax(Open[i],Close[i]); xobu[i] = MathMin(Open[i],Close[i]); }
         manageArrow(i);
   }
   manageAlerts();
   return(0);         
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(ForSymbol+" "+timeFrameToString(timeFrame)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," XO trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"XO "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && ShowArrows && ForSymbol==Symbol())
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,139,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,139,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+(string)time; ObjectDelete(lookFor);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string s = str; StringToUpper(s); return(s);
}